using System;

namespace Fadd.IO.Consoles
{
    /// <summary>
    /// Arguments used when a command have been entered into a console window.
    /// </summary>
    public class CommandEventArgs : EventArgs
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="CommandEventArgs"/> class.
        /// </summary>
        /// <param name="command">The command.</param>
        /// <param name="arguments">The arguments.</param>
        public CommandEventArgs(string command, params string[] arguments)
        {
            Command = command;
            Arguments = arguments;
        }

        /// <summary>
        /// Gets all arguments
        /// </summary>
        public string[] Arguments { get; set; }

        /// <summary>
        /// Gets command entered
        /// </summary>
        public string Command { get; set; }
    }
}