﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using Fadd.Messaging;

namespace Fadd.Messaging
{

    class RequestAsyncResult<TRequestContext> : RequestAsyncResultBase where TRequestContext : IRequestContext
    {
        public TRequestContext Context { get; set; }
        private List<AsyncExceptionWrapper> _exceptions = new List<AsyncExceptionWrapper>();

        public IEnumerable<IHandlerOf<TRequestContext>> Subscribers
        {
            get;
            set;
        }

        public IEnumerable<AsyncExceptionWrapper> Exceptions
        {
            get { return _exceptions; }
        }

        public override void Invoke()
        {
            foreach (var subscriber in Subscribers)
            {
                try
                {
                    subscriber.ProcessRequest(Context);
                    if (Context.Cancel)
                    {
                        Completed();
                        return;
                    }
                }
                catch (Exception err)
                {
                    _exceptions.Add(new AsyncExceptionWrapper(subscriber, err));
                }
            }
            Completed();
        }

        private void Completed()
        {
            IsCompleted = true;
            ((ManualResetEvent)AsyncWaitHandle).Set();
        }
    }

    public class AsyncExceptionWrapper
    {
        public AsyncExceptionWrapper(object source, Exception exception)
        {
            
        }

    }
}
